
#define F_CPU 16000000

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <string.h>



#define FALSE 0x00
#define TRUE 0x01
#define ANALOG 0x01
#define DIGITAL 0x02
#define TEXT_FIX 0x03
#define TEXT_CUSTOM 0x04

int LedBarAngle;
unsigned char Pos;
unsigned int Incr;

unsigned char LatchedIrData;

unsigned char Sec;
unsigned char Min;
unsigned char Hrs;

int SecAngle;
int MinAngle;
int HrsAngle;

unsigned char Mode;

unsigned char TimeString[50], TextString[200], textCustom[60];
unsigned char *TimeStringPtr, *TextStringPtr;
const char *text[] = {"UPB  ACS","PROIECT 2010","CORINA GEBOIU" };
int tx = -1, lenCustom, lenTextCust = 0;
unsigned char validChr, lastNo=0, lastChr = 0, i;

const unsigned char table[38][6] = {{ 0x3e, 0x41, 0x41, 0x41, 0x3e, 0x00 },  // 0 
                                    { 0x00, 0x21, 0x7f, 0x01, 0x00, 0x00  }, // 1 
                                    { 0x21, 0x43, 0x45, 0x49, 0x31, 0x00  }, // 2 
                           			{ 0x42, 0x41, 0x51, 0x69, 0x46, 0x00  }, // 3
                                    { 0x0c, 0x14, 0x24, 0x5f, 0x04, 0x00  }, // 4
                                    { 0x72, 0x51, 0x51, 0x51, 0x4e, 0x00  }, // 5
                                    { 0x1e, 0x29, 0x49, 0x49, 0x06, 0x00  }, // 6
                                    { 0x40, 0x47, 0x48, 0x50, 0x60, 0x00  }, // 7
                                    { 0x36, 0x49, 0x49, 0x49, 0x36, 0x00  }, // 8
                                    { 0x30, 0x49, 0x49, 0x4a, 0x3c, 0x00  }, // 9
                                    { 0x00, 0x36, 0x36, 0x00, 0x00, 0x00  }, // :
                                    { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00  },// space
									{ 0x3f, 0x48, 0x48, 0x48, 0x3f, 0x00  },// A
									{ 0x7f, 0x49, 0x49, 0x49, 0x36, 0x00  },//B
									{ 0x3e, 0x41, 0x41, 0x41, 0x22, 0x00  },//C
									{ 0x7f, 0x41, 0x41, 0x41, 0x3e, 0x00  },//D
									{ 0x7f, 0x49, 0x49, 0x49, 0x41, 0x00  },//E
									{ 0x7f, 0x48, 0x48, 0x48, 0x40, 0x00  },//F
									{ 0x3e, 0x41, 0x41, 0x49, 0x2e, 0x00  },//G
									{ 0x7f, 0x08, 0x08, 0x08, 0x7f, 0x00  },//H
									{ 0x00, 0x00, 0x7f, 0x00, 0x00, 0x00  },//I
									{ 0x06, 0x01, 0x01, 0x01, 0x7e, 0x00  },//J
									{ 0x7f, 0x08, 0x14, 0x22, 0x41, 0x00  },//K
									{ 0x7f, 0x01, 0x01, 0x01, 0x01, 0x00  },//L
									{ 0x7f, 0x20, 0x18, 0x20, 0x7f, 0x00  },//M
									{ 0x7f, 0x10, 0x08, 0x04, 0x7f, 0x00  },//N
									{ 0x3e, 0x41, 0x41, 0x41, 0x3e, 0x00  },//O
									{ 0x7f, 0x48, 0x48, 0x48, 0x30, 0x00  },//P
									{ 0x3f, 0x41, 0x41, 0x43, 0x3f, 0x00  },//Q
									{ 0x7f, 0x48, 0x4c, 0x4a, 0x31, 0x00  },//R
									{ 0x32, 0x49, 0x49, 0x49, 0x26, 0x00  },//S
									{ 0x40, 0x40, 0x7f, 0x40, 0x40, 0x00  },//T
									{ 0x7e, 0x01, 0x01, 0x01, 0x7e, 0x00  },//U
									{ 0x70, 0x0e, 0x01, 0x0e, 0x70, 0x00  },//V
									{ 0x7f, 0x02, 0x0c, 0x02, 0x7f, 0x00  },//W
									{ 0x63, 0x14, 0x08, 0x14, 0x63, 0x00  },//X
									{ 0x60, 0x10, 0x0f, 0x10, 0x60, 0x00  },//Y
									{ 0x43, 0x45, 0x49, 0x51, 0x61, 0x00  },//Z
									};






void Time(unsigned char);
void Display(void);
void CopyData(int Value);
void CopyDot(void);
void CopyText(int Value);
void loadTextCust();
void loadTextFix();


int main()
{
	PORTA = 0x00;
	DDRA =0xFF; //PA0...PA7 ca iesire

	PORTB &=~(1<<PB2); //fara rezistenta de pull-up
	DDRB &= ~(1<<PB2); // PB2 (INT2) ca intrare

	PORTD |= (1<<PD0); //LED17 (rosu) ON
	DDRD |= (1<<PD0); //PD0 ca iesire si LED17 (rosu) ON
	PORTD &= ~(1<<PD6);//fara rezistenta de pull-up
	DDRD &= ~(1<<PD6); //PD6 (ICP) ca intrare

	//INT2

	MCUCSR &= ~(1<<ISC2);//INT2 genereaza intrerupere pe falling edge
	GICR |= (1<<INT2);//INT2 enable
	
	//Timer0

	TCCR0 |= (1<<CS02)|(1<<CS00);//prescaler 1024
	TIMSK |= (1<<TOIE0); //interrupt enable on Timer0 overflow

	//Timer1

	TCCR1B |= (1<<CS11)|(1<<CS10); //prescaler 64
	TCCR1B |= (1<<ICES1); //Input Capture on rising edge
	TIMSK |= (1<<OCIE1A)|(1<<TICIE1);//interrupt enable on Timer1 Compare Match A & interrupt enable on Timer1 Input Capture


	Hrs = 0;
	Min = 0;
	Sec = 0;
	Mode = ANALOG;

	sei(); 

	while(1)
	{
	   for (i=0;i<200;i++);
	   if ( LatchedIrData == 0xbb ) Time(TRUE);  //tasta Last Program
	   if ( LatchedIrData == 0xb3 ) Mode = DIGITAL; //tasta Menu right
	   if ( LatchedIrData == 0xb4 ) Mode = ANALOG;  //tasta Menu left
	   if ( LatchedIrData == 0xf4 ) { Mode = TEXT_FIX; loadTextFix(); } //tasta Menu up
	   if ( LatchedIrData == 0xf5 ) Mode = TEXT_CUSTOM; //tasta Menu down
	   if ( Mode == TEXT_CUSTOM ) loadTextCust();
	   else { lastChr = 0; validChr = 0; lenTextCust = 0; }							
							
	   LatchedIrData = 0;

	}

}

void loadTextFix() 
{
	TextStringPtr = &TextString[0];
	tx++; if ( tx == 3 ) tx=0;
	int v;
	for ( v = 0; v < strlen(text[tx]); v++ ) 
		CopyText(text[tx][v]);

	_delay_ms(200); 
}

void loadTextCust()
{
	if ( LatchedIrData == 0 ) return;
	
	char k, ch = 0, ch0;
	if ( lenTextCust == 0 )
	{ 
		TextStringPtr = &TextString[0];
		
		if ( lenCustom > 0 ) {
			lenTextCust = lenCustom;
			int v;
			for ( v = 0; v < lenTextCust ; v++ ) 
				CopyText(textCustom[v]);
		}
		
	}
	switch ( LatchedIrData ) {
		case 0x80 : k = 0; ch = '1'; ch0 = '1'; break;//tasta 1
		case 0x81 : k = 3; ch = 'A'; ch0 = '2'; break;//tasta 2
		case 0x82 : k = 3; ch = 'D'; ch0 = '3'; break;//tasta 3
		case 0x83 : k = 3; ch = 'G'; ch0 = '4'; break;//tasta 4
		case 0x84 : k = 3; ch = 'J'; ch0 = '5'; break;//tasta 5
		case 0x85 : k = 3; ch = 'M'; ch0 = '6'; break;//tasta 6
		case 0x86 : k = 4; ch = 'P'; ch0 = '7'; break;//tasta 7
		case 0x87 : k = 3; ch = 'T'; ch0 = '8'; break;//tasta 8
		case 0x88 :	k = 4; ch = 'W'; ch0 = '9'; break;//tasta 9
		case 0x89 : k = 1; ch = ' '; ch0 = '0'; break;//tasta 0
		case 0x9d : lenCustom =  lenTextCust; validChr = 0; break; //validare char (tasta-/--)
		case 0x94 : validChr = 0; //stergere (tasta MUTE)
					if ( lenTextCust > 0 ) {  
						lenTextCust--;	
						lenCustom = lenTextCust;
						TextStringPtr -= 6; 
					}
					break;
		case 0xb3 : Mode = DIGITAL; break; //tasta Menu right
		case 0xb4 : Mode = ANALOG; break;  //tasta Menu left
		case 0xf4 : Mode = TEXT_FIX; break;  //tasta Menu up
		case 0xf5 : Mode = TEXT_CUSTOM; break; //tasta Menu down
	}
	if ( ch != 0 ) {
		if ( validChr == 0 )
		{
			lastChr = ch;
			lenTextCust++; 
		}
		else
		{
			if ( lastChr == ch ) 
			{ 
				lastNo++;
				if ( lastNo > k ) lastNo = 0;
			}
			else lastNo = 0;
			lastChr = ch;
			if ( lastNo == k ) ch = ch0;
			else ch += lastNo;
		}
		if ( validChr == 1 && TextStringPtr > 0 ) TextStringPtr -= 6;
		textCustom[lenTextCust-1] = ch;
		CopyText(ch);
		validChr = 1;
	}
	_delay_ms(200); 
}

void Time(unsigned char Fast)
{
if (Fast == FALSE) Sec++;
else Sec += 60;
if (Sec > 59)
   {
   Sec = 0;
   Min++;
   if (Min > 59)
        {
     Min = 0;
     Hrs++;
     if (Hrs > 11)
       {
       Hrs = 0;
       }
     }
   }

if (Mode == ANALOG)
   {
   SecAngle = Sec*6;  //pozitie Secundar
   MinAngle = Min*6;  //pozitie Minutar
   HrsAngle = (Hrs*30)+(Min/2); //pozitie Orar
   }
else
	if (Mode == DIGITAL)
   {
		TimeStringPtr = &TimeString[0];
		CopyData(Hrs);
		CopyDot();
		CopyData(Min);
		CopyDot();
		CopyData(Sec);
	}
}


void CopyData(int Value)
{
if (Value < 10)
   {
   for (i=0;i<6;i++) *TimeStringPtr++ = table[0][i];
   for (i=0;i<6;i++) *TimeStringPtr++ = table[Value][i];
   }
else
   {
   for (i=0;i<6;i++) *TimeStringPtr++ = table[Value/10][i];
   for (i=0;i<6;i++) *TimeStringPtr++ = table[Value-((Value/10)*10)][i];
   }
}


void CopyDot(void)
{
for (i=0;i<6;i++) *TimeStringPtr++ = table[10][i];
}


void CopyText(int Value)
{
int k = 12 + Value - 'A';
if (Value == (int)' ')
	k = 11;
else
	if ( Value <= (int)'9' ) k = Value-'0';	
  
for (i=0;i<6;i++) *TextStringPtr++ = table[k][i];
}

//Rutina de tratare a intreruperii generate de senzorul magnetic la trecerea prin pozitia de referinta (INT2)

ISR(INT2_vect) 
{
static unsigned int LastCount;
static unsigned int TotalCount;
static int Latch;
static unsigned char Lap;

Latch = TCNT1;
TotalCount = Latch - LastCount;
LastCount = Latch;
Lap++;
if (Lap > 150) //nu calculez la fiecare rotatie ci doar din 150 in 150 de rotatii
   {
   Incr = TotalCount / 369; //cat este necesar pt parcurgerea unui arc de 1 grad
   Lap = 0;
   }

LedBarAngle = 0;
OCR1A = Latch + Incr;
TIFR |= (1<<TOV1);
Display();
}


//Rutina de tratare a intreruperii generate la parcurgerea unui unghi de 1 grad
ISR(TIMER1_COMPA_vect)  
{
OCR1A = TCNT1 + Incr;
Display();
}


void Display(void)
{
PORTA = 0x00;

if (Mode == ANALOG)
   {
   if (LedBarAngle == HrsAngle) PORTA = 0x80;
   if (LedBarAngle == MinAngle) PORTA = 0xff;
   if (LedBarAngle == SecAngle) PORTA |= 0x03;
   

   if ((LedBarAngle == 0) ||
      (LedBarAngle == 30) ||
     (LedBarAngle == 60) ||
     (LedBarAngle == 90) ||
     (LedBarAngle == 120) ||
     (LedBarAngle == 150) ||
     (LedBarAngle == 180) ||
     (LedBarAngle == 210) ||
     (LedBarAngle == 240) ||
     (LedBarAngle == 270) ||
     (LedBarAngle == 300) ||
     (LedBarAngle == 330)) PORTA |= 0x01;
   }
else
	if (Mode == DIGITAL)
   {
	
		Pos = ((LedBarAngle-100) / 3);
		if (Pos < 49)
        {
			PORTA = TimeString[48-Pos];
		}
	}
   else 
		//if (Mode == TEXT_FIX || Mode == TEXT_CUSTOM )
		{
			int ls = TextStringPtr - TextString;
			Pos = ((LedBarAngle-(180 - (ls*3)/2)) / 3);
			if (Pos < ls )
			{
				PORTA = TextString[ls-Pos-1];
			}
		}
LedBarAngle++;
}


//Rutina de tratare a intreruperii generata la aparitia unui front crescator pe intrarea de captura (ICP este conectat la receptorul IR)
//nr_impulsuri=(F_CPU/prescaler)*latime_bit
//(prescaler setat anterior la 64)
//bit=START daca latime_bit=5*T=5*0.6ms=3ms =>nr_impulsuri=750
//bit=1 daca latime_bit=3*T=3*0.6ms=1.8ms => nr_impulsuri=450
//bit=0 daca latime_bit=2*T=2*0.6ms=1.2ms => nr_impulsuri=300
ISR(TIMER1_CAPT_vect)
{
static unsigned int LastCapture;
unsigned int PulseWidth;
static unsigned int IrPulseCount;
static unsigned int IrData;

PulseWidth = ICR1 - LastCapture;
LastCapture = ICR1;


if (PulseWidth > 500) //avem bit START
   {
   IrPulseCount = 0;
   IrData = 0;
   }
else
   {
   IrData = IrData >> 1; 
   if (PulseWidth > 350) //avem bit "1"; daca nu, avem bit "0"
	   IrData = IrData | 0x8000;
   IrPulseCount++;
   if (IrPulseCount == 12) //pachet complet
	   LatchedIrData = ((IrData >> 4) & 0x00ff);
   }
}

//Rutina de tratare a intreruperii generata de overflow la Timer0
//(prescaler setat anterior la 1024)
//(1/F_CPU)*prescaler*(256-4)=1 secunda
ISR(TIMER0_OVF_vect)
{
static unsigned char Tick;
Tick++;
if (Tick > 62)
   {
   Time(FALSE);
   Tick = 0;
   }
TCNT0 = 0x04; // reload counter
}